var url, xmlRequest, theRSSFeed;
var artRequest = null;
var secondRequest = null;
var artStream, adName, artArray = new Array();

var feedBaseURL = "http://rs.enewsdata.com/a1/?q=";
var refreshThis = { lastAction:'changeSubject', lastURL:feedBaseURL + subjectSelection.innerText };// [ lastAction: changeSubject, rssAdd, search, cycle ]


var topNews = new Array('Top Business', 'Top Entertainment', 'Top Health', 'Top Internet', 'Top Life', 'Top Offbeat', 'Top Politics', 'Top Sports', 'Top Technology', 'Top World', 'Top News');
var mainMenu = new Array('Cycle Top News', '(-', 'Top News', 'Business', 'Entertainment', 'Health', 'Internet', 'Life', 'Offbeat', 'Politics', 'Sports', 'Technology', 'World');
var subMenus = new Array();
subMenus["Business"] = [ "Cycle Business", "(-", "Top Business", "Advertising", "Agriculture", "Aviation", "Careers", "Consumer", "Electronics", "Energy", "Finance", "Insurance", "Investing", "Manufacturing", "Marketing", "Personal Finance", "Real Estate", "Small Business", "Stocks", "Telecom" ];
subMenus["Entertainment"] = [ "Cycle Entertainment", "(-", "Top Entertainment", "Arts", "Books", "Journalism", "Media", "Movies", "Music", "Radio", "Television", "Theater" ];
subMenus["Health"] = [ "Cycle Health", "(-", "Top Health", "Aging", "Cancer", "Diets", "Medicine", "Pharmacy", "Psychology" ];
subMenus["Internet"] = [ "Cycle Internet", "(-", "Top Internet", "E-Commerce", "Search Engines", "Spam", "Webmaster", "XML" ];
subMenus["Life"] = [ "Cycle Life", "(-", "Top Life", "Autos", "Collecting", "Culture", "Dining", "Education", "Family", "Fashion", "Garden", "Home", "Libraries", "Motorcycles", "Outdoors", "Pets", "Shopping", "Travel" ];
subMenus["Offbeat"] = [ "Cycle Offbeat", "(-", "Top Offbeat", "Reference", "Special Features", "Weather" ];
subMenus["Politics"] = [ "Cycle Politics", "(-", "Top Politics", "Election", "Environment", "Government", "Intellectual Property", "Law", "Opinion", "Religion", "Terrorism" ];
subMenus["Sports"] = [ "Cycle Sports", "(-", "Top Sports", "Baseball", "Basketball", "Boxing", "College Basketball", "College Football", "College Sports", "Cricket", "Football", "Golf", "Hockey", "Horse Racing", "Motor Sports", "Olympics", "Rugby", "Sailing", "Soccer", "Tennis" ];
subMenus["Technology"] = [ "Cycle Technology", "(-", "Top Technology", "Accessibility", "Apple", "Computers", "Database", "Games", "Handheld", "Hardware", "Information Technology", "Intel", "Linux", "Microsoft", "Networking", "Open Source", "Operating System", "Programming", "RFID", "Robots", "Science", "Security", "Software", "Space", "Video", "Virus", "VOIP", "Wireless" ];
subMenus["World"] = [ "Cycle World", "(-", "Top World", "Africa", "Americas", "Asia", "Australia", "Canada", "Europe", "India", "Iraq", "Ireland", "Middle East", "United Kingdom", "United States" ];

var dayNames = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
var monthNames = new Array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
var contentArray = new Array();

var goRSSVisible = false;
var resizeRSSTimer;
var resizeInterval = 0;

var isPlaying = false;
var playTimer;
var playInterval = 100;
var autoScrollPause = 15;
var scrollPosition = 0;
var scrollDirection = 1;

var recentSearchCount = 10;
var recentSearches = new Array();

var autoUpdateEvery = (1000 * 60 * 15);// 15 minutes
var updateTimer;

var cycleEvery = (1000 * 60 * 2);// 2 minutes
var cycleThis = 0;
var cycleThese = new Array();
var cycleTimer;

var fadeInTimer;
var fadeInterval = 0;

var menuOpen = false;
var hideMenuTimer;
var menuHideAfter = 1500;// 1.5 seconds

var menuOff = true;

var bX = 0;
var docked = true;




function init() {
	pluginHelper.onDisplayTargetChange = onDisplayTargetChange;
	
	view.onpopout = onPopout;
	view.onpopin = onPopin;
		
	positionPlay();

	getFeed();
	
	fillMainMenu();
	
	updateTimer = setInterval("updateNews()", autoUpdateEvery);
	
	view.onclick = function a() { clearTimeout(hideMenuTimer); if(menuOpen) hideMenus(); }
}

function onDisplayTargetChange(displayTarget) {
	if (displayTarget == gddTargetSidebar) {
		dockedLogo.visible = true;
		container.visible = false;
		
		docked = true;
	} else if (displayTarget == gddTargetFloatingView) {
		dockedLogo.visible = false;
		container.visible = true;
		
		docked = false;
	}
}

function onPopout() {
	view.width = 581;
	
	dockedLogo.visible = false;
	container.visible = true;
	container.x = -120;
	bX = 120;
}

function onPopin() {
	view.width = 581;
	
	dockedLogo.visible = true;
	container.visible = false;
	container.x = 0;
	
	bX = 0;
}




function updateNews() {
	//debug.trace('updating: ' + refreshThis["lastURL"]);
	clearInterval(cycleTimer);
	getFeed();
}

function cycleNews(selection) {
	clearInterval(updateTimer);
	clearInterval(cycleTimer);//in case we were just cycling a set of subjects
	cycleThis = 0;//reset in case cycling through another array already
	
	selection = selection.substring( 6, selection.length );
	
	if ( selection == 'Top News' ) {
		cycleThese = topNews;
	} else {
		cycleThese = subMenus[selection];
		cycleThese = cycleThese.slice(2, (cycleThese.length));
	}
	
	performCycle();//make first call manually
	cycleTimer = setInterval("performCycle()", cycleEvery);
}

function performCycle() {
	//debug.trace('cycling: ' + cycleThese[cycleThis]);
	subjectSelection.innerText = cycleThese[cycleThis];
	refreshThis['lastAction'] = 'cycle';
	refreshThis['lastURL'] = feedBaseURL + cycleThese[cycleThis];
	getFeed();
	cycleThis++;
	if (cycleThis > cycleThese.length - 1 ) cycleThis = 0;
}




function fillMainMenu() {

	for ( i = 0; i< mainMenu.length; i++ ) {
		var newButton, newLabel;
		newButton = "<button  width='100%' height='15' x='0' y='" + (i*15) + "' ";

		if (mainMenu[i] == "(-") {
			newButton += "image='Images/Separator_gray.png' onmouseover='mySubMenu.visible=false;' ";
		} else if (mainMenu[i].indexOf('Cycle') != -1) {
			newButton += "overimage='Images/SubMenuOver.gif' onmouseover='mySubMenu.visible=false;' onclick='hideMenus(); cycleNews(\"" + mainMenu[i] + "\");' ";
		} else if (mainMenu[i].indexOf('Top') != -1) {
			newButton += "overimage='Images/SubMenuOver.gif' onmouseover='mySubMenu.visible=false;' ";
			newButton += "onclick='changeSubject(\"" + mainMenu[i] + "\")' ";
		} else {
			newButton += "image='Images/SubMenuOff.png' overimage='Images/SubMenuOver.png' ";
			newButton += "onmouseover='fillSubmenu(\"" + mainMenu[i] + "\"); mySubMenu.visible=true;' ";
			newButton += "onclick='changeSubject(\"" + mainMenu[i] + "\")' ";
		}
		
		newButton += " />";
		
		myMenuContent.appendElement(newButton);

		if (mainMenu[i] != "(-") {
			newLabel = "<label x='4' y='" + (i*15 + 2) + "' font='Helvetica' size='7' bold='true'>" + mainMenu[i] + "</label> ";
			myMenuContent.appendElement(newLabel);
		}
		
		myMenuContent.height = mainMenu.length * 15;
		myMenu.height = myMenuContent.height + 2;
		myMenu.y = 404 - myMenu.height;
	}

}

function fillSubmenu(subject) {
	
	if(!subMenus[subject]) { mySubMenu.visible=false; return; }
	
	mySubMenuContent.removeAllElements();
	
	for ( i = 0; i< subMenus[subject].length; i++ ) {
		var subButton, subLabel;
		subButton = "<button  width='100%' height='15' x='0' y='" + (i*15) + "' ";
		if (subMenus[subject][i] == "(-") {
			subButton += "image='Images/Separator_gray.png' ";
		} else if (subMenus[subject][i].indexOf('Cycle') != -1) {
			subButton += "name='" + subMenus[subject][i] + "' overimage='Images/SubMenuOver.gif' onclick='hideMenus(); cycleNews(\"" + subMenus[subject][i] + "\");' ";
		} else {
			subButton += "name='" + subMenus[subject][i] + "' overimage='Images/SubMenuOver.gif' ";
			subButton += "onclick='subjectSelection.innerText = \"" + subMenus[subject][i] + "\"; refreshThis.lastAction=\"changeSubject\"; refreshThis.lastURL = feedBaseURL + subjectSelection.innerText; getFeed(); myMenu.visible = false; mySubMenu.visible=false; balloon.opacity=255;' ";
		}

		subButton += " />";
		
		mySubMenuContent.appendElement(subButton);
		
		if (subMenus[subject][i] != "(-") {
			subLabel = "<label x='4' y='" + (i*15 + 2) + "' font='Helvetica' size='7' bold='true'>" + subMenus[subject][i] + "</label> ";
			mySubMenuContent.appendElement(subLabel);
		}
		
		mySubMenuContent.height = subMenus[subject].length * 15;
		mySubMenu.height = mySubMenuContent.height + 2;
		mySubMenu.y = 404 - mySubMenu.height;
		
		if (mySubMenu.y < 0) mySubMenu.y = 0;
	}
}

function fillSearchMenu() {
	recentSearchesContent.removeAllElements();

	if (recentSearches.length == 0) {
		var noneLabel = "<label x='5' y='1' font='Arial' size='8' bold='false' color='#999999'>No Recent Searches</label>";
		recentSearchesContent.appendElement(noneLabel);
		recentSearchesContent.height = 16;
		recentSearchesMenu.height = 18;
		return;
	}

	var recentLabel = "<label x='5' y='1' font='Arial' size='8' bold='false' color='#999999'>Recent Searches</label>";
	recentSearchesContent.appendElement(recentLabel);
	
	for ( i = 0; i < recentSearches.length; i++ ) {
		var searchButton = "<button height='16' width='100%' x='0' y='" + (16 + (i*16 )) + "' onclick='repeatSearch(\"" + recentSearches[i] + "\");' overimage='Images/SearchMenuOver.gif' />";
		var searchLabel = "<label x='5' y='" + (16 + (i*16 )) + "' font='Arial' size='8' bold='false' color='#000000'>" + recentSearches[i] + "</label>";
		recentSearchesContent.appendElement(searchButton);
		recentSearchesContent.appendElement(searchLabel);
	}
		
	var dividerButton = "<button x='0' y='" + ((recentSearches.length + 1) * 16) + "' height='16' width='100%' overimage='Images/SubMenuOver.gif' />";
	var divider = "<img src='Images/Separator_gray.png' height='15' width='100%' y='" + ((recentSearches.length + 1) * 16) + "' />";
	recentSearchesContent.appendElement(dividerButton);
	recentSearchesContent.appendElement(divider);
	
	
	var clearButton = "<button x='0' y='" + ((recentSearches.length + 2) * 16) + "' onclick='recentSearches.length=0; recentSearchesMenu.visible=false; searchEntry.value=\"\";' height='16' width='100%' overimage='Images/SearchMenuOver.gif' />";
	var clearLabel = "<label x='5' y='" + ((recentSearches.length + 2) * 16) + "' font='Arial' size='8' bold='false' color='#000000'>Clear Recent Searches</label>";
	recentSearchesContent.appendElement(clearButton);
	recentSearchesContent.appendElement(clearLabel);
	
	var newHeight = (recentSearches.length + 3) * 16;
	recentSearchesContent.height = newHeight;
	recentSearchesMenu.height = newHeight + 2;
}

function timeMenus() {
	
	var mX = view.event.x;
	var mY = view.event.y;
		
	var menuX = myMenu.x;
	var menuY = myMenu.y;
	var menuW = myMenu.width;
	var menuH = myMenu.height;
	
	if (!docked) bX = 0;
	
	if (myMenu.visible) {
		if ( mX + bX > menuX && mX + bX < (menuX + menuW) && mY > menuY && mY < (menuY + menuH) ) {
	
			clearTimeout(hideMenuTimer);
			hideMenuTimer = null;
			menuOff = false;
			return;
		}
	}
	
	if (mySubMenu.visible) {
			
		var submenuX = mySubMenu.x;
		var submenuY = mySubMenu.y;
		var submenuW = mySubMenu.width;
		var submenuH = mySubMenu.height;
		
		if ( mX + bX > submenuX && mX + bX < (submenuX + submenuW) && mY > submenuY && mY < (submenuY + submenuH) ) {
			clearTimeout(hideMenuTimer);
			hideMenuTimer = null;
			menuOff = false;
			return;
		}
	}
	
	if (recentSearchesMenu.visible) {
		clearTimeout(hideMenuTimer);
		hideMenuTimer = null;
		menuOff = false;
		return;
	}
	
	//debug.trace('hiding menus!');
	
	menuOff = true;
	moveBalloon();

	if(hideMenuTimer == null) {
		clearTimeout(hideMenuTimer);
		hideMenuTimer = setTimeout("hideMenus()", menuHideAfter);
	}	
}

function hideMenus() { 
	myMenu.visible = false; 
	mySubMenu.visible = false; 
	moveBalloon();
	recentSearchesMenu.visible = false;
	
	menuOpen = false;
	menuOff = true;
}




function positionPlay() {
	pausePlayButton.y = 116 + scrollBar.value / (scrollBar.max/(scrollBar.height-70.5)) + 28;
}

function scrollChange() {
	rssContent.y = -scrollBar.value;
	scrollPosition = +scrollBar.value;
	
	firstAd.y = rssContent.y + 136;
	secondAd.y = rssContent.y + 298;

	positionPlay();
}

function autoScroll() {
	if (isPlaying) {
		if (scrollDirection == 1) {
			if ( scrollPosition > (scrollBar.max + autoScrollPause) ) {
				scrollDirection = -scrollDirection;
			}
		} else if (scrollDirection == -1) {
			if ( (scrollBar.min - autoScrollPause) > scrollPosition ) {
				scrollDirection = -scrollDirection;
			}
		}
		scrollPosition += scrollDirection;
		scrollBar.value += scrollDirection;
	}
}

function toggleAutoScroll() {
	isPlaying = !isPlaying;
	
	if (isPlaying) {
		pausePlayButton.image = 'Images/PauseUp.png';
		pausePlayButton.downimage = 'Images/PauseDown.png';

		playTimer = setInterval("autoScroll()", playInterval);
	} else {
		pausePlayButton.image = 'Images/PlayUp.png';
		pausePlayButton.downimage = 'Images/PlayDown.png';

		clearInterval(playTimer);
	}

}




function fillBalloon(item) {
	balloonTitle.innerText = contentArray[item].title;
	balloonDescription.innerText = contentArray[item].description;
	balloonDate.innerText = contentArray[item].date;
}

function moveBalloon() {
	var x = view.event.x;
	var y = view.event.y;
	var bottom = goRSSVisible? 334 : 365;
	var listHeight = rssContent.height + 116;
	var maxY = Math.min(bottom, listHeight);
	
	if ( x + bX < 166 || x + bX > 386 || y < 116 || y > maxY ) {
		hideBalloon();
		return;
	} else if (!menuOff) {
		hideBalloon();
		return;
	} else {
		if(balloon.visible == false) {
			//debug.trace('start fadeInBalloon');
			fadeInTimer = setInterval("fadeInBalloon()", fadeInterval);
		}

		if (playTimer) clearInterval(playTimer);

		//if (!docked) bX = 0;
		
		docked ? balloon.x = x - 160 + bX : balloon.x = x - 160;
		
		//balloon.x = x - 160 + bX;
		balloon.y = y - 116;
		balloon.visible = true;
	}
}

function fadeInBalloon() {
	balloon.opacity += (.1 * 255);
	//debug.trace('fadeInBallon: ' + balloon.opacity);

	if (balloon.opacity > 254) clearInterval(fadeInTimer);
}

function hideBalloon() {
	clearInterval(fadeInTimer);
	balloon.visible = false;
	balloon.opacity = 0;

	if (isPlaying) {
		if (playTimer) clearInterval(playTimer);
		playTimer = setInterval("autoScroll()", playInterval);
	}
}




function toggleRSS() {
	goRSSVisible = !goRSSVisible;
	goRSSVisible ? d = 1 : d = -1;
	
	menuOff = true;
	moveBalloon();

	if(resizeRSSTimer) clearInterval(resizeRSSTimer);
	resizeRSSTimer = setInterval("resizeRSS()", resizeInterval);
	
	if(goRSSVisible) { rssAddButton.image = "Images/RSSOnUp.png"; rssAddButton.downimage = "Images/RSSOnDown.png"; } 
	else { rssAddButton.image = "Images/RSSOffUp.png"; rssAddButton.downimage = "Images/RSSOFFDown.png"; }

	goRSSEntry.focus();//FIX: doesn't work?
}

function resizeRSS() {
	if ( 1 == d && goRSS.height >= 29 ) return false;
	else if ( -1 == d && 0 >= goRSS.height ) return false;

	goRSS.y -= d;
	goRSS.height += d;
	scrollArea.height -= d;
	scrollBar.height -= d;
	myTrack.height -= d;

	if (rssContent.height < scrollArea.height) {
		scrollBar.max = 0;
		pausePlayButton.visible = false;
		if (isPlaying) {
			clearInterval(playTimer);
			isPlaying = false;
		}
		scrollBar.visible = false;
		myTrack.visible = true;
	} else {
		scrollBar.max = ( (rssContent.height - scrollArea.height) * scrollBar.height / scrollArea.height );
		scrollBar.visible = true;
		pausePlayButton.visible = true;
		myTrack.visible = false;
	}
	
	if (scrollBar.value > scrollBar.max) scrollBar.value = scrollBar.max;
	if (scrollBar.value < scrollBar.min) scrollBar.value = scrollBar.min;
	
	positionPlay();
}

function toggleRecentSearches() {
	if (!recentSearches.visible) fillSearchMenu();//if we are about to show recent searches, fill the menu first

	recentSearchesMenu.visible = !recentSearchesMenu.visible;
	
	clearTimeout(hideMenuTimer);
	
	//menuOff = !recentSearchesMenu.visible;
	
	//menuOpen = recentSearchesMenu.visible;
	
	myMenu.visible = false;
	mySubMenu.visible = false;
}

function toggleMenu() {
	myMenu.visible = !myMenu.visible;
	if (!myMenu.visible) mySubMenu.visible = false;
	
	recentSearchesMenu.visible = false;
}




function getFeed() {
	url = refreshThis['lastURL'];
	
	xmlRequest = new XMLHttpRequest();
	xmlRequest.open("GET", url, "true");
	xmlRequest.onreadystatechange = parseFeed;
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 1978 00:00:00 GMT");
	xmlRequest.send();
}

function parseFeed() {

	if ( xmlRequest.readyState == 4 && xmlRequest.status == 200) {
		
		//debug.trace(refreshThis['lastAction'] + ": " + refreshThis['lastURL'] );
		
		var lastAction = refreshThis['lastAction'];
				
		rssContent.removeAllElements();
		contentArray.length = 0;
		
		theRSSFeed = xmlRequest.responseText;
				
		var xml = new DOMDocument();
		xml.loadXML(theRSSFeed);
		var results = xml.getElementsByTagName("item");
		
		var resultsCount = results.length;
		
		if(refreshThis["lastAction"] == "rssAdd") {
			firstAd.visible = false;
			secondAd.visible = false;
		} else {
			firstAd.visible = resultsCount > 0;
			secondAd.visible = resultsCount > 10;
		}
		
		rssContent.height = 27 * resultsCount;
		
		for ( n = 0; n < resultsCount; n++ ) {
			var itemTitle='', itemDescription='', itemURL='', artLink='', pubDate='', itemDate='';
			
			for ( var node = results[n].firstChild; node != null; node = node.nextSibling ) {
				if ( node.nodeName == 'title' )
					itemTitle = node.firstChild.nodeValue;
				else if ( node.nodeName == 'link' )
					itemURL = node.firstChild.nodeValue;
				else if ( node.nodeName == 'description' ) {
					if (node.firstChild) itemDescription = node.firstChild.nodeValue;
				} else if ( node.nodeName == 'pubDate' )
					pubDate = node.firstChild.nodeValue;
				else if ( node.nodeName == 'newsQube:art' ) {
					if (node.firstChild) artLink = node.firstChild.nodeValue;
				}
			}
			
			itemTitle = itemTitle.replace(/\n/g,"");
			itemTitle = itemTitle.replace(/\r/g,"");
			itemTitle = itemTitle.replace(/\&/g,"");
			
			if ( pubDate != "" ) {
				var d, day, month, date, year;
				
				d = new Date(pubDate);
				day = d.getUTCDay();
				month = d.getUTCMonth();
				date = d.getUTCDate();
				year = d.getUTCFullYear();
				
				itemDate = dayNames[day] + ', ' + monthNames[month] + ' ' + date + ', ' + year;
			}

			var tempArray = { title:itemTitle, description:itemDescription, date:itemDate, link:itemURL };			
			contentArray[n] = tempArray;
			tempArray = null;
			
			if (!artLink) {
				rssContent.appendElement("<button height='27' width='100%' y='" + (n * 27) + "' image=\"Images/ItemSeparator.gif\" overimage=\"Images/ItemSeparatorOver.png\" onmouseover='fillBalloon(" + n + ");' onclick='showPage(" + n + ")' onmousewheel='hideBalloon(); scrollBar.value -= (event.wheeldelta / 120) * 5;' />");
				rssContent.appendElement("<label x='4' y='" + ((n * 27) + 6) + "' width='96%' wordwrap='false' trimming='character-ellipsis' underline='false' font='Arial' size='8' color='#bac5cc' vAlign='middle'>" + itemTitle + "</label>");
			} else {
				rssContent.appendElement("<button height='27' width='100%' y='" + (n * 27) + "' image=\"Images/ItemSeparator.gif\" overimage=\"Images/ItemSeparatorOver.png\" onmouseover='fillBalloon(" + n + ");' onclick='showPage(" + n + ")' onmousewheel='hideBalloon(); scrollBar.value -= (event.wheeldelta / 120) * 5;' />");

				if (!artRequest) fetchAdArt(artLink);
				else fetchSecondAd(artLink);
			}
		}
		
		if (rssContent.height < scrollArea.height) {
			scrollBar.value = 0;
			clearInterval(playTimer);
			isPlaying = false;
			pausePlayButton.image = 'Images/PlayUp.png';
			pausePlayButton.downimage = 'Images/PlayDown.png';
			
			scrollBar.visible = false;
			pausePlayButton.visible = false;
			myTrack.visible = true;
		} else {
			scrollBar.max = ( (rssContent.height - scrollArea.height) * scrollBar.height / scrollArea.height );
			if (scrollBar.value > scrollBar.max) scrollBar.value = 0;
			scrollBar.visible = true;
			pausePlayButton.visible = true;
			myTrack.visible = false;

			positionPlay();
		}
		
		var adOffset = 136;
		
		if (contentArray.length < 6) {
			var amountLess = 6 - contentArray.length;
			adOffset -= (amountLess * 27);
		}
		
		firstAd.y = rssContent.y + adOffset;

	} else return;
}

function fetchAdArt(artURL) {
	artRequest = new XMLHttpRequest();
	artRequest.open("GET", artURL, true);
	artRequest.onreadystatechange = onArtData;
	artRequest.setRequestHeader("Cache-Control", "no-cache");
	artRequest.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 1978 00:00:00 GMT");
	artRequest.send();
}

function onArtData() {
	if ( artRequest.readyState == 4 && artRequest.status == 200) {

		firstAd.src = artRequest.responseStream;
		var newX = (rssContent.width - firstAd.srcWidth)/2;
		firstAd.x = newX;
		firstAd.height = 26;
		firstAd.width = 208;
		
		artRequest = null;
	}
}

function fetchSecondAd(artURL) {
	secondRequest = new XMLHttpRequest();
	secondRequest.open("GET", artURL, true);
	secondRequest.onreadystatechange = onOtherData;
	secondRequest.setRequestHeader("Cache-Control", "no-cache");
	secondRequest.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 1978 00:00:00 GMT");
	secondRequest.send(null);
}

function onOtherData() {
	if ( secondRequest.readyState == 4 && secondRequest.status == 200) {

		secondAd.src = secondRequest.responseStream;
		var newX = (rssContent.width - secondAd.srcWidth)/2;
		secondAd.x = newX;
		secondAd.height = 26;
		secondAd.width = 208;

		secondRequest = null;
	}
}



function changeSubject(subject) {
	subjectSelection.innerText = subject; 
	
	clearInterval(cycleTimer); 
	clearInterval(updateTimer); 

	refreshThis.lastAction="changeSubject"; 
	refreshThis.lastURL = feedBaseURL + subjectSelection.innerText;
	
	updateTimer = setInterval("updateNews()", autoUpdateEvery); 
	
	getFeed();
	
	hideMenus();
	balloon.visible = true;
}

function loadCustomRSS() {
	if (goRSSEntry.value == "") return;

	toggleRSS();

	clearInterval(cycleTimer);
	clearInterval(updateTimer);

	refreshThis['lastAction'] = 'rssAdd';
	refreshThis['lastURL'] = safeURL(goRSSEntry.value);
	
	updateTimer = setInterval("updateNews()", autoUpdateEvery);

	getFeed();
}

function performSearch() {
	clearInterval(cycleTimer); 
	clearInterval(updateTimer); 
	
	refreshThis['lastAction'] = 'search';
	refreshThis['lastURL'] = feedBaseURL + searchEntry.value;
	
	getFeed();
}

function refresh() {
	var lastAction = refreshThis['lastAction'];
	
	if (lastAction == 'cycle') return;

	clearInterval(updateTimer);
	
	if (lastAction != 'search' ) updateTimer = setInterval("updateNews()", autoUpdateEvery);
	
	getFeed();
}

function repeatSearch(term) {
	clearInterval(cycleTimer); 
	clearInterval(updateTimer); 

	searchEntry.value = term;
	performSearch();
	
	recentSearchesMenu.visible = false;
}

function onkeypress(sender) {
	if( event.keyCode == 13 || event.keyCode == 3 ) {
		if ( sender=="search" ) {
			for ( search in recentSearches) {
				if ( searchEntry.value == recentSearches[search] ) recentSearches.splice(search,1);
			}
			recentSearches.unshift(searchEntry.value);
			if (recentSearches.length > recentSearchCount) recentSearches.length = recentSearchCount;
			
			performSearch();
		} else {
			loadCustomRSS();
		}
		event.returnValue = false;
	}
}




function showPage(n) {
	var url = contentArray[n].link;
	var shell = new ActiveXObject("WScript.Shell");

	shell.run(url);
	//shell.run("firefox.exe " + url);
	//shell.run("iexplore.exe " + url);
	
	shell.quit;
	shell = null;
}

function safeURL(url) {
	return url.replace(/^feed:\/\//, "http://")
}



/*

//removing the html special characters
// I didnt found any other solution other than this..

titleStr = titleStr.replace(/&#[0-9]+;/g," ");
titleStr = titleStr.replace(/&quot;/g,"'");
titleStr = titleStr.replace(/&amp;/g,"&");
var indx_bar = titleStr.lastIndexOf("-");
curItem.heading = titleStr.substring(0,indx_bar-1);
//curItem.source = link;
curItem.source = titleStr.substring(indx_bar+1, titleStr.length);

*/